import time
import ctypes
#import numpy as np
import matplotlib.pyplot as plt


CHANNEL = 256
CHANNEL_1 = CHANNEL * 2
len_In = 10
range_ddc=0
Data_format = 0 # 0 for 16 bit and 1 for 20 bit

#Capacitor integration range selection for DDC1128 chip
if range_ddc == 0:
    Range_arr= [0x0000, 0x0000, 0x1100, 0x1200, 0x1C00, 0x1D00, 0x1F01,
                0x0000, 0x0000, 0x1E01]
if range_ddc == 1:
    Range_arr= [0x0000, 0x0000, 0x1100, 0x1200, 0x1C02, 0x1D00, 0x1F01,
                0x0000, 0x0000, 0x1E01]    
if range_ddc == 2:
    Range_arr= [0x0000, 0x0000, 0x1100, 0x1200, 0x1C04, 0x1D00, 0x1F01,
                0x0000, 0x0000, 0x1E01]
if range_ddc == 3:
    Range_arr= [0x0000, 0x0000, 0x1100, 0x1200, 0x1C06, 0x1D00, 0x1F01,
                0x0000, 0x0000, 0x1E01]   


Range_arr[4] = Range_arr[4] + Data_format # Will set the bit 8 of DDC 
#configuration register if data format is 1
Hard_reser_arr = [0x0000, 0x15FF, 0x15FF, 0x1500, 0x1500, 0x15FF, 0x15FF] 


#Argument types for DLL function
short_p = ctypes.POINTER(ctypes.c_short) #16bit representation ...2 bytes
int_p = ctypes.POINTER(ctypes.c_int) #32bit representation ...4 bytes
double_p = ctypes.POINTER(ctypes.c_double) #64bit representation ...8 bytes

#arrays definitions for DLL functions
#For XferINTDataIn function
short_arr_len = ctypes.c_short * 4096
short_arr_len_1 = ctypes.c_short * 2048

#For FPGAwrite function
int_arr_255 = ctypes.c_int * 255

#For FPGAwrite function
double_arr_256 = ctypes.c_double * CHANNEL
double_arr_512 = ctypes.c_double * CHANNEL_1

#load DLL
dll = ctypes.WinDLL("USB_IO_for_VB6.dll")

#XferINTDataIn
xfer_data_In = dll.XferINTDataIn
xfer_data_In.argtypes = [short_p, short_p, int_p]
xfer_data_In.restype = ctypes.c_short

#XferINTDataOut
xfer_data_Out = dll.XferINTDataOut
xfer_data_Out.argtypes = [short_p, short_p, short_p, short_p, short_p]
xfer_data_Out.restype = ctypes.c_short

# FPGAwrite
Write_fpga = dll.WriteFPGARegsC
Write_fpga.argtypes = [short_p, ctypes.c_int, int_p, int_p, int_p]
Write_fpga.restype = ctypes.c_int

# Fast data access
fast_data = dll.FastAllDataCap
fast_data.argtypes = [double_p, double_p, double_p, double_p, double_p,
                      ctypes.c_int, ctypes.c_int, ctypes.c_int, double_p,
                      int_p]
fast_data.restype = ctypes.c_int

#Arguments initialisation for function fast data
AVGArr = double_arr_512()
RMSArr = double_arr_512()
P2PArr = double_arr_512()
MAXArr = double_arr_512()
MINArr = double_arr_512()
ArrSize = ctypes.c_int(CHANNEL_1)
Channels = ctypes.c_int(CHANNEL)
Samples = ctypes.c_int(2)
DataArray = double_arr_512()
AllDataAorBfirst = ctypes.c_int(0)

#Arguments for function FPGAwrite
USBdev = ctypes.c_short()
DUTSelect = ctypes.c_int()
RegsIn = int_arr_255()
RegsOut = int_arr_255()
RegEnable = int_arr_255()

#Arguments for function XferINTDataIn
Array_Data = short_arr_len()
Array_Data_1 = short_arr_len_1()
DataLen = ctypes.c_int(512)


#Hard reset
count=0
for i in range(7):
    RegH = ctypes.c_short((Hard_reser_arr[i]>>12) & 0x000F)
    RegL = ctypes.c_short((Hard_reser_arr[i]>>8) & 0x000F)
    DataH = ctypes.c_short((Hard_reser_arr[i]>>4) & 0x000F)
    DataL = ctypes.c_short((Hard_reser_arr[i]) & 0x000F)
    ret = xfer_data_Out(USBdev, RegH, RegL, DataH, DataL)
    
    if ret == 0:
        count= count+1
if count == 7:
    print("Hard reset given!!")
else:
    print("Hard reset Unsucessfull!!")

#Read from DDC

#ret = xfer_data_In(USBdev, Array_Data, DataLen)
#print("\nFunction returned: {:d}".format(ret))
#print("Output register array: {:s}".format(" ".join(["{:d}".format(item) for
#      item in Array_Data])))


#configure range in DDC register
#for i in range(10):
#    RegH = ctypes.c_short((Range_arr[i]>>12) & 0x000F)
#    RegL = ctypes.c_short((Range_arr[i]>>8) & 0x000F)
#    DataH = ctypes.c_short((Range_arr[i]>>4) & 0x000F)
#    DataL = ctypes.c_short((Range_arr[i]) & 0x000F)
#    ret = xfer_data_Out(USBdev, RegH, RegL, DataH, DataL)
#print("Range configuration done!!")

#ret = xfer_data_In(USBdev, Array_Data, DataLen)
#print("\nFunction returned: {:d}".format(ret))
#print("Output register array: {:s}".format(" ".join(["{:d}".format(item) for
#      item in Array_Data])))
#
#Array_Data_1 = Array_Data[::2]    
#print("Output register array: {:s}".format(" ".join(["{:d}".format(item) for
#      item in Array_Data_1])))
    
    
#FPGA read operation

ret = Write_fpga(USBdev, DUTSelect, RegsIn, RegsOut, RegEnable)
if (ret==0):
    print("Sucessfully acquired the data from FPGA")
else:
    print("Unsucessfully in acquiring the data from FPGA")
print("\nFunction returned: {:d}".format(ret))
#print("Output register array: {:s}".format(" ".join(["{:d}".format(item) for
#      item in RegsOut])))
print("DVALIDS (Samples) to Ignore: {:d}".format(RegsOut[0x0C]))
print("DVALIDS (Samples) to Read MSB: {:d}".format(RegsOut[0x0D]))
print("DVALIDS (Samples) to Read MIDB: {:d}".format(RegsOut[0x0E]))
print("DVALIDS (Samples) to Read LSB: {:d}".format(RegsOut[0x0F]))
print("Firmware version: {:d}".format(RegsOut[0x5E]<<8|RegsOut[0x5F]))
if ((RegsOut[9] & 0x10) == 0x10):
    print("Data Format: 20 bits")
if ((RegsOut[8] & 0x01) == 0x01):
    print("DDC Data Clock: Running mode")
else:
    print("DDC Sys Clock: Low mode")

if ((RegsOut[0x0B] & 0x01) == 0x01):
    print("DDC Data Clock: Running mode")
else:
    print("DDC Data Clock: Low mode")


#FPGA write operation

RegsIn[0x09] = 0x08
RegEnable[0x09] = 1
ret = Write_fpga(USBdev, DUTSelect, RegsIn, RegsOut, RegEnable)
print("Function returned: {:d}".format(ret))
print("Output register array: {:s}".format(" ".join(["{:d}".format(item) for
      item in RegsOut])))
print("\nDVALIDS (Samples) to Ignore: {:d}".format(RegsOut[0x0C]))
print("DVALIDS (Samples) to Read MSB: {:d}".format(RegsOut[0x0D]))
print("DVALIDS (Samples) to Read MIDB: {:d}".format(RegsOut[0x0E]))
print("DVALIDS (Samples) to Read LSB: {:d}".format(RegsOut[0x0F]))
print("Firmware version: {:d}".format(RegsOut[0x5E]<<8|RegsOut[0x5F]))
RegEnable[0x09] = 0



#Fastdata aquire and plot
ret = fast_data(AVGArr, RMSArr, P2PArr, MAXArr, MINArr, ArrSize,
                Channels, Samples, DataArray, ctypes.byref(AllDataAorBfirst))
print("Function returned: {:d}".format(ret))
print("Output register array: {:s}".format(" ".join(["{:f}".format(item) for
      item in DataArray])))
plt.plot(DataArray)
plt.show()
